       program exclurad
c	latest update: Jan.7, 2003
c      version 1.1  December 31, 2000
c
c      Andrei Afanasev	 afanas@jlab.org
c      Igor Akushevich	    aku@jlab.org
c      Volker Burkert	burkert@jlab.org
c      Kyungseon Joo	   kjoo@jlab.org
c
c modified for d(e,e'p)n 2/10/4: Jerry Gilfoyle gilfoyle@jlab.org
c
      implicit real*8(a-h,o-z)
      common/cmp/pi,alpha,amp,amp2,ap,ap2,aml2,amu2,amh2,barn
      common/keys/ivec,iphy,newcase
      common/born/w,w2,q2,s,x,sx,sxp,sqlw0,ssh0,xxh0,sxtm0,sqll
     .	   ,cosh,phih,sinh,vmax,vv10,vv20,vvp0,vvm0,t0	!  /born/
     .	   ,cos1,sin1,cos2,sin2,ee1,ee2,pp1,pp2,eeq,ppq !  /born/
      common/isfisf/isf1,isf2

      parameter(npoimax=10000)
      dimension q2_input(npoimax),w_input(npoimax)
      dimension cscm_input(npoimax),phicm_input(npoimax)
      dimension sibar(2),sigar(2),silar(2)
      parameter (netx=1)
      parameter (nety=6)
      parameter (nett=2)
      dimension wnet(netx),q2net(nety),ctnet(nett)
      data wnet/1.5d0/
     .	   q2net/0.7d0,1d0,1.3d0,1.5d0,1.8d0,2.0d0/
     .	   ctnet/-.1d0,-.3d0/
      data ipolmax/1/

      common/test/ipol

      include "deep_input.inc"

	 open(unit=22,file='radcor.dat',status='unknown')
	 open(unit=41,file='radsigpl.dat',status='unknown')
	 open(unit=42,file='radsigmi.dat',status='unknown')
	 open(unit=27,file='radasm.dat',status='unknown')
	 open(unit=28,file='radtot.dat',status='unknown')
	 open(unit=5,file='input.dat',status='old')

	  read(5,*)iphy
	  read(5,*)ll
	  read(5,*)bmom
	  read(5,*)tmom
	  read(5,*)lepton
	  read(5,*)ivec
	  read(5,*)cutv
	  read(5,*)npoi

	  if (npoi.ge.1)then
	    read(5,*)(w_input(i),i=1,npoi)
	    read(5,*)(Q2_input(i),i=1,npoi)
	    read(5,*)(cscm_input(i),i=1,npoi)
	    read(5,*)(phicm_input(i),i=1,npoi)
	  elseif (npoi.eq.-100) then
	    ii = 0
	    read(5,*)w_dummy
	    read(5,*)q2_dummy
	    do ic = 1, 10
	       csthcm_dummy = -0.9+(ic-1)*0.2
	       do ip = 1, 1
		  ii = ii + 1
		  phicm_dummy = 15.+(ip-1)*30
		  q2_input(ii) = q2_dummy
		  w_input(ii)  = w_dummy
		  cscm_input(ii) = csthcm_dummy
		  phicm_input(ii) = phicm_dummy
	       enddo
	    enddo
	    npoi = ii
	  else
c	     if(intphi.ne.1)stop 'intphi must be =1 for npoi=0'
	    do it=1,nett
	      do ix=1,netx
		do iy=1,nety
		  npoi=npoi+1
		  w_input(npoi)=wnet(ix)**2
		  q2_input(npoi)=q2net(iy)
		  cscm_input(npoi)=ctnet(it)
		enddo
	      enddo
	    enddo
	  endif

	 call titout('03.31.2000')
	 write(9,'(a8,f8.3)')' bmom  =',bmom
	 write(9,'(a8,f8.3)')' tmom  =',tmom
	 write(9,'(a8,i2)')' lepton=',lepton
	 write(9,'(a8,i2)')' ivec  =',ivec
	 write(9,'(a8,f6.3)')' cutv  =',cutv
	 write(9,'(a8,i3)')' npoi  =',npoi

	 call setcon(ivec,lepton)

      s=2.*(sqrt(tmom**2+amp*amp)*sqrt(bmom**2+aml2)+bmom*tmom)

      print *, 'npoi=', npoi, ' data points'

c start loop over the number of cases here!!!

      do  i=1,npoi
        newcase = 1
	w=w_input(i)
	q2=q2_input(i)

	if(ivec.eq.1)then
	  cosh= -cscm_input(i)
	  phih=pi+phicm_input(i)*pi/180d0
	elseif(ivec.eq.2)then
	  cosh=  cscm_input(i)
	  phih=phicm_input(i)*pi/180d0
	endif

cgpg        print *,'reached borntest.'
       call borntest(bmom,w,q2,cscm_input(i),phicm_input(i)*pi/180.
     .			 ,sibtu,sibtp,eps_d)

cgpg        print *,'reached bornkin.'
       call bornkin(cutv)

       do ipol=1,ipolmax
cgpg       do ipol=2,ipolmax
	 if(ipol.eq.1)then
	   isf1=1
	   isf2=4
	   sibt=sibtu
	 elseif(ipol.eq.2)then
	   isf1=5
	   isf2=5
	   sibt=sibtp
	 endif

cgpg        print *,'reached bornin.'
       call bornin(sib)
cgpg        print *,'past bornin.'

       sum=vacpol(q2)

       dlm=log(q2/aml2)

cgpg        print *,'reached fspen function.'
cgpg        print *,'amp2=',amp2,' ssh0=',ssh0,' xxh0=',xxh0
       deltavr=(1.5d0*dlm-2.d0-.5d0*log(xxh0/ssh0)**2
     .		    +fspen(1d0-amp2*q2/ssh0/xxh0)-pi**2/6.d0)


cgpg        print *,'past fspen.'
       delinf=(dlm-1.d0)*log(vmax**2/ssh0/xxh0)
       extai1=exp(alpha/pi*delinf)

	tai=0.
c	 taill=0.
cgpg        print *,'ll=',''
	if(ll.ne.1)then 
cgpg        print *,'reached qqt.'
	  call qqt(tai)
	endif
	
cgpg        print *,'reached qqtll.'
	call qqtll(taill)

       sig=sib*extai1*(1.d0+alpha/pi*(deltavr+sum))+tai
       sigll=sib*extai1*(1.d0+alpha/pi*(deltavr+sum))+taill
c
cgpg       write(*,'(a8,8g11.3)') ' test : ',sib,sibt,sib/sibt

       if(ipol.eq.1)ddcr=sig/sib

       write(22,'(4f8.4,x,f8.2,f8.4,x,e8.2,f8.4)')w,q2,eps_d,cscm_input(i),
     1  phicm_input(i),sig/sib,sib/sibt,sigll/sib

       write(*,'(4f8.4,x,f8.2,f8.4,x,e8.2,f8.4)') w,q2,eps_d,cscm_input(i),
     1  phicm_input(i),sig/sib,sib/sibt,sigll/sib

c      write(*,'(8f8.5)') extai1-1.,alpha/pi*(deltavr+sum),tai/sib

       silar(ipol)=sigll
       sigar(ipol)=sig
       sibar(ipol)=sib

       enddo

       dd=1.
       if(ipolmax.eq.2)then
	 asb=sibar(2)/sibar(1)*1d2
	 as =sigar(2)/sigar(1)*1d2
	 asl=silar(2)/silar(1)*1d2
	 dd=(as-asb)/asb*1d2
	 dl=(asl-asb)/asb*1d2


	 write(27,'(5f6.2,5F8.3)')
     .	 w,q2,eps_d,cscm_input(i),phicm_input(i),as,asb,dd
	 write(41,'(5f6.2,2g11.3)')
     . 	 w,q2,eps_d,cscm_input(i),phicm_input(i)
     .	,sibar(1)+sibar(2),sigar(1)+sigar(2)
	 write(42,'(5f6.2,2g11.3)')
     .	 w,q2,eps_d,cscm_input(i),phicm_input(i)
     .	,sibar(1)-sibar(2),sigar(1)-sigar(2)
       endif

       write(28,'(5f6.2,5F8.3)')
     .	   e1,w,q2,cscm_input(i),phicm_input(i),ddcr,dd

      enddo
      close(22)
      end



****************** setcon *************************************

      subroutine setcon(ivec,lepton)
      implicit real*8(a-h,o-z)
      common/cmp/pi,alpha,amp,amp2,ap,ap2,aml2,amu2,amh2,barn
      parameter(ncases=2)
      dimension amhad(ncases),amunm(ncases)
cgpg      data amhad/0.938272d0,0.13957d0/
cgpg      data amunm/0.13957d0,0.938272d0/
      data amhad/0.938272d0,0.938272d0/
      data amunm/0.939565d0,0.939565d0/

      if(lepton.eq.1)aml2=.261112d-6
      if(lepton.eq.2)aml2=.111637d-1
      pi=3.1415926d0
      alpha=.729735d-2
      barn=.389379d6
      amh2=amhad(ivec)**2
      amu2=amunm(ivec)**2

cgpg original value of amp

cgpg      amp=.938272d0

cgpg is the mass below the undetected particle or the target??
cgpg
cgpg andrei says its the target.

cgpg      amp=0.939565d0
      amp=1.875611d0

      amp2=amp**2
      ap=2d0*amp
      ap2=2d0*amp2

      end



****************** bornkin *************************************

      subroutine bornkin(cutv)
      implicit real*8(a-h,o-z)
      common/cmp/pi,alpha,amp,amp2,ap,ap2,aml2,amu2,amh2,barn
      common/born/w,w2,q2,s,x,sx,sxp,sqlw0,ssh0,xxh0,sxtm0,sqll
     .	   ,cosh,phih,sinh,vmax,vv10,vv20,vvp0,vvm0,t0 !  /born/
     .	   ,cos1,sin1,cos2,sin2,ee1,ee2,pp1,pp2,eeq,ppq !  /born/

      w2=w**2
      sx=w2+q2-amp2
      x=s-sx
      sxp=s+x
      aly=sx**2+4.*amp2*q2
      sqly=dsqrt(aly)
      eeq=(sx-2.*q2)/2./w
      ppq=sqly/2./w

      vmax=w2-amu2+amh2-2.*sqrt(w2)*sqrt(amh2)	- 1d-8
      if(cutv.gt.1d-12)vmax=min(vmax,cutv)


      u1=s-q2
      u2=x+q2
      ee1=u1/2./w
      ee2=u2/2./w
      sql1=sqrt(u1**2-4.*w2*aml2)
      sql2=sqrt(u2**2-4.*w2*aml2)
      pp1=sql1/2./w
      pp2=sql2/2./w
      cos1=(u1*(sx-2.*q2)+2.*q2*w2)/sqly/sql1
      cos2=(u2*(sx-2.*q2)-2.*q2*w2)/sqly/sql2
      sql12=sqrt(q2*u1*u2-q2**2*w2-aml2*aly)
      sin1=2.*w*sql12/sql1/sqly
      sin2=2.*w*sql12/sql2/sqly
      sqll=sqrt(q2*u1*u2-q2**2*w2-aml2*aly)


      sinh=sqrt(1d0-cosh**2)
      eeh0=(w2+amh2-amu2)/2./w
      sqlw0=sqrt((w2+amh2-amu2)**2-4.*w2*amh2)
      pph0=sqlw0/2./w

cgpg       print *,w2,amh2,amu2,sqlw0,w
cgpg       print *,ee1,eeh0,pp1,pph0,cosh,cos1,sinh,sin1,cos(phih)
cgpg       print *,ee2,pp2,cos2,sin2
      vv10=2d0*(ee1*eeh0-pp1*pph0*(cosh*cos1+sinh*sin1*cos(phih)))
      vv20=2d0*(ee2*eeh0-pp2*pph0*(cosh*cos2+sinh*sin2*cos(phih)))

cgpg       print *,'x=',x,' q2=',q2,' vv20=',vv20
      ssh0=x+q2-vv20
cgpg       print *,'s=',s,' vv10=',vv10
      xxh0=s-q2-vv10
      t0=-q2-vv10+vv20+amh2

      sxtm0=sx+t0+amp2-amu2

c     write(*,'(a8,2g11.3)')' test1: ',sin1**2+cos1**2
c     write(*,'(a8,2g11.3)')' test2: ',sin2**2+cos2**2
c     write(*,'(a8,2g11.3)')' test3: ',sinh**2+cosh**2
c     write(*,'(a8,2g11.3)')' test4: ',pph0**2+amh2,eeh0**2
c     write(*,'(a8,2g11.3)')' test5: ',pp1**2+aml2,ee1**2
c     write(*,'(a8,2g11.3)')' test6: ',pp2**2+aml2,ee2**2
c     write(*,'(a8,2g11.3)')' test7: ',ppq**2-eeq**2,q2
c     write(*,'(a8,2g11.3)')' test8: ',w2+amh2-2.*w*eeh0,amu2

      end

****************** borntest *************************************
      subroutine borntest(bmom,w,q2,csin,phih,sig0bu,sig0bp,eps_d)
      implicit real*8(a-h,o-z)
      common/cmp/pi,alpha,amp,amp2,ap,ap2,aml2,amu2,amh2,barn
      common/keys/ivec,iphy,newcase

	enu = 0.5d0*(w**2+q2-amp2)/amp
	bmom_prime = bmom - enu
	cthe = 1.d0-q2/(2.0*bmom*bmom_prime)
	the_e = acos(cthe)
	eps_d= 1d0/(1d0+2d0*(1d0+enu*enu/q2)*tan(0.5d0*the_e)**2)

	call phy_model(iphy,q2,w,csin
     .	 ,2*ivec-1,sig_t,sig_l,sig_tt,sig_lt,sig_ltp)

c	write(*,'(5g12.4)')q2,w,csin
c	 write(*,'(5g12.4)')sig_t,sig_l,sig_tt,sig_lt,sig_ltp

	sig0b = sig_t + eps_d*sig_l + eps_d*sig_tt*cos(2d0*phih*0)
     .	 + sqrt(eps_d*(eps_d+1d0)/2d0)*sig_lt*cos(phih*o)
	sig0b=sig0b * alpha/2d0/pi*bmom_prime/bmom*(w**2-amp2)
     .	 /2./amp/q2/(1d0-eps_d)
cgpg        write (6,999) sig0b,sig_t,sog_l,sig_tt,sig_lt

	sig0bu=sig0b*pi/2./amp/bmom/bmom_prime
cgpg        write (6,999) sig0b,sig_t,sog_l,sig_tt,sig_lt

cgpg
cgpg  calculate the cross section and test to see if it goes negative.
cgpg  this is the likely source of the unphysical, negative radiative
cgpg  correction factors we now get when the response functions are small
cgpg  at high beam energy (5.75 GeV) and at perpendicular angles 
cgpg  (cos(theta)= -0.35-0.35).
cgpg
cgpg if the cross section drops below a certain value, set the response functions
cgpg to their last, above-threshold values. this is rather crude, but it is 
cgpg reasonable efficient and the response functions are below any physically
cgpg relevant value.
cgpg
cgpg first test to see if the structure functions give a below-threshold
cgpg cross section first time through. this may indicate a deeper problem
cgpg so we bail out at this point.

      threshold = 0.0
      if (sig0bu .lt. threshold .and. newcase .eq. 1) then
         print *,'   ************ WARNING IN BORNTEST! ************'
         print *,' '
         print *,'The first cross section calculated is',sig0bu,'.'
         print *,' '
         print *,'You are getting very small or even negative cross'
         print *,'sections from your structure functions. We bail'
         print *,'out at this point. See the website for guidance'
         print *,'or get in touch with me.'
         print *,'                            Jerry Gilfoyle'
         print *,'                            gilfoyle@jlab.org'
         print *,' '
cgpg         write (6,999) sig0b,sig_t,sog_l,sig_tt,sig_lt
 999     format('sig0bu=',e8.2,' sig_t=',e8.2,' sig_l=',e8.2,' sig_tt=',
     1           e8.2,' sig_lt=',e8.2)
         print *,'sig0bu = ',sig0bu,' nu=',enu,' w=',W,' q2=',q2
         print *,'epsilon=',eps_d,' phi=',phih,' sig0b=',sig0b
         print *,'Eprime=',bmom_prime,' W2=',W**2,' amp2=',amp2
         print *,'amp=',amp,' Q2=',q2
         print *,'W=',sqrt(w2),'-------------------------------'
         print *,'W=',sqrt(w2),'-------------------------------'
         print *,'W=',sqrt(w2),'-------------------------------'
         sl  = 0.0
         st  = 0.0
         slt = 0.0
         stt = 0.0
         sl_old = sl
         st_old = st
         slt_old = slt
         stt_old = stt
         stop
      else if (sig0bu .lt. threshold) then
cgpg         write (6,999) sig0bu,st,sl,stt,slt
cgpg         print *,'sig0bu = ',sig0bu,' nu=',enu,' w=',w,' q2=',q2
cgpg         print *,'epsilon=',eps_d,' phi=',phih,' sig0b=',sig0b
cgpg         print *,'Eprime=',bmom_prime,' W2=',W**2,' amp2=',amp2
cgpg         print *,'amp=',amp,' Q2=',q2
cgpg         print *,'W=',sqrt(w2),'-------------------------------'
         sl  = sl_old
         st  = st_old
         slt = slt_old
         stt = stt_old
      else
         sl_old = sl
         st_old = st
         slt_old = slt
         stt_old = stt
         newcase = 0
      end if

	sig0b =
     .	 + sqrt(eps_d*(-eps_d+1d0)/2d0)*sig_ltp*sin(phih)
	sig0b=sig0b * alpha/2d0/pi*bmom_prime/bmom*(w**2-amp2)
     .	 /2./amp/q2/(1d0-eps_d)

	sig0bp=sig0b*pi/2./amp/bmom/bmom_prime

      end


****************** bornin *************************************

      subroutine bornin(sibor)
      implicit real*8(a-h,o-z)
      common/cmp/pi,alpha,amp,amp2,ap,ap2,aml2,amu2,amh2,barn
      common/born/w,w2,q2,s,x,sx,sxp,sqlw0,ssh0,xxh0,sxtm0,sqll
     .	   ,cosh,phih,sinh,vmax,vv10,vv20,vvp0,vvm0,t0	!  /born/
     .	   ,cos1,sin1,cos2,sin2,ee1,ee2,pp1,pp2,eeq,ppq !  /born/
      dimension tb(5),sfm0(5)
      common/isfisf/isf1,isf2

cgpg       print *,'reached subtm0.'
       call subtm0(5,tb)
       call sffun(sfm0,q2,w2,t0,phih)
       
cgpg       print *,'past sffun.'


       ssu=0d0
       do isf=isf1,isf2
	  ssu=ssu+tb(isf)*sfm0(isf)
       enddo

       sibor=alpha**2*sqlw0/(32.*pi**2*w2*s**2*q2**2) * ssu

cgpg        print *,'reached END of sffun.'

       end



      subroutine subtm0(ntm,tb)
      implicit real*8(a-h,o-z)
      dimension tb(ntm)
      common/cmp/pi,alpha,amp,amp2,ap,ap2,aml2,amu2,amh2,barn
      common/born/w,w2,q2,s,x,sx,sxp,sqlw0,ssh0,xxh0,sxtm0,sqll
     .	   ,cosh,phih,sinh,vmax,vv10,vv20,vvp0,vvm0,t0	!  /born/
     .	   ,cos1,sin1,cos2,sin2,ee1,ee2,pp1,pp2,eeq,ppq !  /born/

      TB(1)=Q2
      TB(2)=(-AMP2*Q2+S*X)/2.
      TB(3)=(-AMH2*Q2+Vv10*Vv20)/2.
      TB(4)=(-Q2*SXTM0+S*Vv20+X*Vv10)/2.

      sqla=sqrt(q2*(s-q2)*(x+q2)-q2**2*W2)
      eps012=sqlw0*sqla/4./w*sinh*sin(phih)

c      tt=(-q2+amh2-vv10+vv20)
c      sxtm=s-x+tt+amp2-amu2
c      eee12=SQRT(-((vv10*x-q2*sxtm+s*vv20)**2
c     .        +4.*(s*x-amp2*q2)*(q2*amh2-vv10*vv20))/16.)
c
c	WRITE(*,*)EPS012,eee12

      TB(5)=-2.*eps012

      end

*************************** qqt *****************************
      subroutine qqt(tai)
      implicit real*8(a-h,o-z)
      external rv2tr
      real*8 rv2tr
      dimension am(3),bm(3),wrk(500)
      common/cmp/pi,alpha,amp,amp2,ap,ap2,aml2,amu2,amh2,barn
      common/born/w,w2,q2,s,x,sx,sxp,sqlw0,ssh0,xxh0,sxtm0,sqll
     .     ,cosh,phih,sinh,vmax,vv10,vv20,vvp0,vvm0,t0  !  /born/
     .     ,cos1,sin1,cos2,sin2,ee1,ee2,pp1,pp2,eeq,ppq !  /born/
      dimension phiar(4),coar(6)

      am(1)=0d0
      bm(1)=vmax

      phiar(1)=0.
      phiar(2)=0.01*pi
      phiar(3)=2d0*pi-0.01*pi
      phiar(4)=2d0*pi

      coar(1)=-1d0
      coar(2)=cos2-0.05d0
      coar(3)=cos2+0.05d0
      coar(4)=cos1-0.05d0
      coar(5)=cos1+0.05d0
      coar(6)=1d0


      ma=100000
      ot=1d-2
cgpg modified values of integration parameters.
      ma=100000
      ot=1d-2

      rere=0.
      do iph=1,3
      do ico=1,5

      am(2)=coar(ico)
      bm(2)=coar(ico+1)
      am(3)=phiar(iph)
      bm(3)=phiar(iph+1)

       if(am(2).gt.bm(2))write(*,*)' am(2)<bm(2)'

      id=1
      mir=100
cgpg      print *,'got to d01fce.'
      call d01fce(3,am,bm,mir,ma,rv2tr,ot,otr,500,wrk,re,id)
      write(9,'(1x,''tai:'',2i3,g13.4,f8.4,i9,i3)')ico,iph,re,otr,mir,id
      write(*,'(1x,''tai:'',2i3,g13.4,f8.4,i9,i3)')ico,iph,re,otr,mir,id
      rere=rere+re
      enddo
      enddo

c     
cgpg      print *,'got to the end of qqt.'
      tai=-alpha**3/(512.*pi**4*s**2*w2**2) * rere

      write(9,'(1x,''tai:'',2g13.4,2i5)')tai,otr,mir,id
      write(*,'(1x,''tai:'',2g13.4,2i5)')tai,otr,mir,id

      end


****************** qqtll **************************************

      subroutine qqtll(taill)
      implicit real*8(a-h,o-z)
      external fvll
      common/cmp/pi,alpha,amp,amp2,ap,ap2,aml2,amu2,amh2,barn
      common/born/w,w2,q2,s,x,sx,sxp,sqlw0,ssh0,xxh0,sxtm0,sqll
     .	   ,cosh,phih,sinh,vmax,vv10,vv20,vvp0,vvm0,t0	!  /born/
     .	   ,cos1,sin1,cos2,sin2,ee1,ee2,pp1,pp2,eeq,ppq !  /born/

	call simpsx(1d-6,vmax,150,1d-3,fvll,taill)

      end

****************** fvll **************************************

      real*8 function fvll(v)
      implicit real*8(a-h,o-z)
      common/cmp/pi,alpha,amp,amp2,ap,ap2,aml2,amu2,amh2,barn
      common/born/w,w2,q2,s,x,sx,sxp,sqlw0,ssh0,xxh0,sxtm0,sqll
     .	   ,cosh,phih,sinh,vmax,vv10,vv20,vvp0,vvm0,t0 !  /born/
     .	   ,cos1,sin1,cos2,sin2,ee1,ee2,pp1,pp2,eeq,ppq !  /born/

      eeh=(w2+amh2-amu2-v)/2./w
      sqlw=sqrt((w2+amh2-amu2-v)**2-4.*w2*amh2)
      pph=sqlw/2./w
      vv1=2d0*(ee1*eeh-pp1*pph*(cosh*cos1+sinh*sin1*cos(phih)))
      vv2=2d0*(ee2*eeh-pp2*pph*(cosh*cos2+sinh*sin2*cos(phih)))

      tt=(-q2+amh2-vv1+vv2)

      sxtm=sx+tt-v+amp2-amu2


      xx=x+q2-vv2
      ss=s-q2-vv1

      z1=1d0-v/ss
      z2=1d0/(1d0+v/xx)

       sigmas=sigm5(z1*s,x,z1*q2,z1*vv1,vv2,sinh,phih)
       sigmax=sigm5(s,x/z2,q2/z2,vv1,vv2/z2,sinh,phih)
       sigma0=sigm5(s,x,q2,vv1,vv2,sinh,phih)

       w2s=z1*s-x-z1*q2+amp2
       w2x=s-x/z2-q2/z2+amp2


      sqlws0=sqrt((w2s+amh2-amu2)**2-4.*w2s*amh2)
      sqlwx0=sqrt((w2x+amh2-amu2)**2-4.*w2x*amh2)

       ccs=sqlw/sqlws0*w2s/w2
       ccx=sqlw/sqlwx0*w2x/w2

      sis=((1d0+z1**2)*ccs*sigmas-2d0*sigma0)/ss/(1d0-z1)
      six=((1d0+z2**2)*ccx*sigmax-2d0*sigma0)*z2/xx/(1d0-z2)

      fvll=alpha/2d0/pi*(log(Q2/aml2)-1d0)*(sis+six)

c     write(33,'(5g12.3)')z1,z2,v
c      pause

      end



       real*8 function sigm5(sz,xz,q2z,v1z,v2z,sinh,phih)
       implicit real*8(a-h,o-z)
       common/cmp/pi,alpha,amp,amp2,ap,ap2,aml2,amu2,amh2,barn
       dimension tb(5),sfm0(5)
      common/isfisf/isf1,isf2

      s=sz
      x=xz
      q2=q2z
      vv1=v1z
      vv2=v2z


      w2=s-x-q2+amp2
      tt=(-q2+amh2-vv1+vv2)
      sqlw0=sqrt((w2+amh2-amu2)**2-4.*w2*amh2)

      sxtm=s-x+tt+amp2-amu2

       call sffun(sfm0,q2,w2,tt,phih)

      TB(1)=Q2
      TB(2)=(-AMP2*Q2+S*X)/2.
      TB(3)=(-AMH2*Q2+Vv1*Vv2)/2.
      TB(4)=(-Q2*SXTM+S*Vv2+X*Vv1)/2.


c      eee12=sqrt(-((vv1*x-q2*sxtm+s*vv2)**2
c     .        +4.*(s*x-amp2*q2)*(q2*amh2-vv1*vv2))/16.)
c	rd12:=moph*sqll/2*sih*sin(phih)$


	  sqll=sqrt(q2*s*x-q2**2*amp2)
	  eee12=sqlw0*sqll/4./sqrt(w2)*sinh*sin(phih)


       tb(5)=-2*eee12
c	write(33,'(5g12.3)')eee12

       ssu=0d0
       do isf=isf1,isf2
	  ssu=ssu+tb(isf)*sfm0(isf)
c	  write(*,'(i5,5g12.4)')isf,ssu,tb(isf),sfm0(isf)
       enddo

       sigm5=alpha**2*sqlw0/(32.*pi**2*w2*s**2*q2**2) * ssu

c	 write(*,'(5g11.3)')w2,q2,tt,sigm5

       end






****************** rv2tr **************************************

      double precision function rv2tr(ndim,arg)
      implicit real*8(a-h,o-z)
      dimension arg(ndim),tm(5,3),tb(5),sfm(5),sfm0(5)
      common/cmp/pi,alpha,amp,amp2,ap,ap2,aml2,amu2,amh2,barn
      common/born/w,w2,q2,s,x,sx,sxp,sqlw0,ssh0,xxh0,sxtm0,sqll
     .	   ,cosh,phih,sinh,vmax,vv10,vv20,vvp0,vvm0,t0	!  /born/
     .	   ,cos1,sin1,cos2,sin2,ee1,ee2,pp1,pp2,eeq,ppq !  /born/
      common/isfisf/isf1,isf2


      phik=arg(3)
      cosk=arg(2)
      vv=arg(1)

      sink2=1.d0-cosk**2
      sink=sqrt(max(0d0,sink2))

      z1=(ee1-pp1*(cos1*cosk+sin1*sink*cos(phik)))/w
      z2=(ee2-pp2*(cos2*cosk+sin2*sink*cos(phik)))/w
       bb=1.
       bi12=bb/(z1*z2)
       bi1pi2=bb/z2+bb/z1
       bis=(bb/z2**2+bb/z1**2)*aml2
       bir=(bb/z2**2-bb/z1**2)*aml2
       bi22m=bb/z2**2*aml2
       bi11m=bb/z1**2*aml2
       hi2=bis-q2*bi12

      eeh=(w2+amh2-amu2-vv)/2./w
      sqlw=sqrt((w2+amh2-amu2-vv)**2-4.*w2*amh2)
      pph=sqlw/2./w
      vv1=2d0*(ee1*eeh-pp1*pph*(cosh*cos1+sinh*sin1*cos(phih)))
      vv2=2d0*(ee2*eeh-pp2*pph*(cosh*cos2+sinh*sin2*cos(phih)))
      fwiw=1d0-(eeh-pph*(cosh*cosk+sinh*sink*cos(phih-phik)))/w

      ta=(eeq-ppq*cosk)/w
      dmu=1d0-fwiw
      r=vv/fwiw

      tt=-q2+amh2-vv1+vv2

      tldq2=q2+r*ta
      tldw2=w2-r
      tldtm=(-q2+amh2-vv1+vv2)-r*(ta-dmu)
      tldtm=tt-r*(ta-dmu)

c	write(22,'(a5,7g11.3)')' tri ',eeh/w,pph/w
c     .  ,w-eeh-r/2./w,sqrt(amu2)
c     .  ,fwiw

       call sffun(sfm,tldq2,tldw2,tldtm,phih)
       call sffun(sfm0,q2,w2,t0,phih)


      sxtm=sx+tt-vv+amp2-amu2

      vpl=vv1+vv2
      vmi=vv1-vv2

       call subtm0(5,tb)

c     TM(1,1)=4.*HI2*Q2
c     TM(1,2)=4.*HI2*TA
c     TM(1,3)=2.*(-2.*BB-BI12*TA**2)
c     TM(2,1)=(HI2*(-4.*AMP2*Q2+SXP**2-SX**2))/2.
c     TM(2,2)=(-4.*AMP2*HI2*TA-BI12*SXP**2*TA+BI1PI2*SXP*SX+2.*
c    . BIR*SXP+2.*HI2*SX)/2.
c     TM(2,3)=(4.*AMP2*BB+2.*AMP2*BI12*TA**2-BI12*SX*TA-BI1PI2*
c    . SXP)/2.
c     TM(3,1)=(HI2*(-4.*AMH2*Q2-VMI**2+VPL**2))/2.
c     TM(3,2)=(-4.*AMH2*HI2*TA-BI12*TA*VPL**2+BI1PI2*VMI*VPL+2.*
c    . BIR*DMU*VPL+2.*DMU*HI2*VMI)/2.
c     TM(3,3)=(4.*AMH2*BB+2.*AMH2*BI12*TA**2-BI12*DMU*TA*VMI-
c    . BI1PI2*DMU*VPL)/2.
c     TM(4,1)=HI2*(-2.*Q2*SXTM+SXP*VPL-SX*VMI)
c     TM(4,2)=(-2.*BI12*SXP*TA*VPL+BI1PI2*SXP*VMI+BI1PI2*SX*VPL+
c    . 2.*BIR*DMU*SXP+2.*BIR*VPL+2.*DMU*HI2*SX-4.*HI2*SXTM*TA+2.*
c    . HI2*VMI)/2.
c     TM(4,3)=(4.*BB*SXTM-BI12*DMU*SX*TA+2.*BI12*SXTM*TA**2-BI12
c    . *TA*VMI-BI1PI2*DMU*SXP-BI1PI2*VPL)/2.


      v1=vv1
      v2=vv2
      tm(1,1)=4.*hi2*q2
      tm(1,2)=4.*hi2*ta
      tm(1,3)=2.*(-2.*bb-bi12*ta**2)
      tm(2,1)=2.*hi2*(-amp2*q2+s*x)
      tm(2,2)=(-4.*amp2*hi2*ta-bi12*s**2*ta-2.*bi12*s*ta*x
     . -bi12*ta*x**2+bi1pi2*s**2-bi1pi2*x**2-2.*bir*s*ta+
     . 2.*bir*s-2.*bir*ta*x+2.*bir*x-2.*hi2*s*ta+2.*hi2*s+
     . 2.*hi2*ta*x-2.*hi2*x)/2.
      tm(2,3)=(4.*amp2*bb+2.*amp2*bi12*ta**2+bi12*s*ta**2-
     . bi12*s*ta-bi12*ta**2*x+bi12*ta*x+bi1pi2*s*ta-bi1pi2
     . *s+bi1pi2*ta*x-bi1pi2*x)/2.
      tm(3,1)=2.*hi2*(-amh2*q2+v1*v2)
      tm(3,2)=(-4.*amh2*hi2*ta-bi12*ta*v1**2-2.*bi12*ta*v1
     . *v2-bi12*ta*v2**2+bi1pi2*v1**2-bi1pi2*v2**2+2.*bir*
     . dmu*v1+2.*bir*dmu*v2+2.*dmu*hi2*v1-2.*dmu*hi2*v2)/
     . 2.
      tm(3,3)=(4.*amh2*bb+2.*amh2*bi12*ta**2-bi12*dmu*ta*
     . v1+bi12*dmu*ta*v2-bi1pi2*dmu*v1-bi1pi2*dmu*v2)/2.
      tm(4,1)=2.*hi2*(-q2*sxtm+s*v2+v1*x)
      tm(4,2)=-bi12*s*ta*v1-bi12*s*ta*v2-bi12*ta*v1*x-bi12
     . *ta*v2*x+bi1pi2*s*v1-bi1pi2*v2*x+bir*dmu*s+bir*dmu*
     . x-bir*ta*v1-bir*ta*v2+bir*v1+bir*v2+dmu*hi2*s-dmu*
     . hi2*x-2.*hi2*sxtm*ta-hi2*ta*v1+hi2*ta*v2+hi2*v1-hi2
     . *v2
      tm(4,3)=(4.*bb*sxtm-bi12*dmu*s*ta+bi12*dmu*ta*x+2.*
     . bi12*sxtm*ta**2+bi12*ta**2*v1-bi12*ta**2*v2-bi12*ta
     . *v1+bi12*ta*v2-bi1pi2*dmu*s-bi1pi2*dmu*x+bi1pi2*ta*
     . v1+bi1pi2*ta*v2-bi1pi2*v1-bi1pi2*v2)/2.



      eee12i=sqrt(-((vv1*x-q2*sxtm+s*vv2)**2
     .	      +4.*(s*x-amp2*q2)*(q2*amh2-vv1*vv2))/16.)

      eee2i=sqrt(- ((vv2*(ta-1.)-dmu*x+sxtm*z2)**2
     .	      +4.*(z2*amp2+(ta-1.)*x)*(-z2*amh2+vv2*dmu))/16.)

      eee1i=sqrt(- ((vv1*(ta-1.)-dmu*s+sxtm*z1)**2
     .	      +4.*(z1*amp2+(ta-1.)*s)*(-z1*amh2+vv1*dmu))/16.)


       eee12=pph*sqll*sinh*sin(phih)/2.
       om=r/2./w
       sqlq=2.*w*ppq
       bee1=(sx*s+ap2*q2)*sin(phik-phih)*pph*sinh*sink/(4.*w*sqlq)
       bee2=(sx*x-ap2*q2)*sin(phik-phih)*pph*sinh*sink/(4.*w*sqlq)
       beee=(sx+ap2)*(sin(phih)*cosk*sinh - sin(phik)*cosh*sink)
     .	   *pph*sqll/(4.*w2*sqlq)
       bbbb = sqll*(sin(phih)*pph*sinh - sin(phik)*eeh*sink)/(4.*w**2)
       eee1=beee+bbbb+bee1
       eee2=beee+bbbb+bee2

c
c	write(*,'(6g12.3)')eee12,eee12i,eee1/eee1i,eee2/eee2i
c	write(*,'(6g12.3)')eee1i/eee2i,eee1/eee2
c	write(*,'(6g12.3)')eee1i,eee2i,eee1,eee2

c bbbb := sqll*(sin(phih)*moph*sih - sin(phik)*eeh*sik)/(4*w**2)$
c rd12:=moph*sqll/2*sih*sin(phih)$
c sin(phih-phik):=sin(phih)*cos(phik)-sin(phik)*cos(phih);
c bee := (sx + 2*m1**2)*
c (sin(phih)*cok*sih - sin(phik)*coh*sik)
c *mok*moph*sqll/(2*w*sqlq)$
c be1 := (sx*s + 2*m1**2*q2)*sin(phik-phih)*mok*moph*sih*sik/(2*sqlq)$
c be2 := (sx*x - 2*m1**2*q2)*sin(phik-phih)*mok*moph*sih*sik/(2*sqlq)$
c rd1:=bee+be1;
c rd2:=bee+be2;

c      bi11m=0d0

       tm(5,1)=-8.*hi2*eee12
       tm(5,2)=4.*(2.*bi11m*eee2 + bi12*(eee12*ta-q2*(eee1+eee2)) +
     .	2.*bi22m*eee1+2.*bi11m*(eee1*s - eee12*ta + eee12 - eee2*s)/s)
       tm(5,3)=2.*( bi1pi2*(eee2-eee1)-bi12*(eee1+eee2)*ta
     .	+4.*bi11m*eee2*(ta-1.)/s)

      podinl=0.
      do  isf=isf1,isf2
      do  irr=1,3
	 pp=sfm(isf)*tm(isf,irr)*sqlw/tldq2**2
	 if(irr.eq.1)
c    .	 pp=pp-sqlw0*tm(isf,1)*sfm0(isf)/q2**2
     .	 pp=pp-4d0*sqlw0*hi2*tb(isf)*sfm0(isf)/q2**2
	 pres=pp*r**(irr-2)
	 podinl=podinl+pres
      if(isf.eq.5.and.r.lt.1d-8.and.irr.eq.1)
     . write(*,'(2i4,7g11.3)')isf,irr,pres,r,sfm(isf),tm(isf,irr)
     . ,tb(isf)*4*hi2,sfm0(isf)
      enddo
      enddo

      rv2tr=podinl/fwiw

c      write(*,'(7g11.3)')podinl,r,tldq2,sqlw
c      if(abs(rv2tr).gt.1d13)then
c      write(22,'(7g11.3)')rv2tr,r,cosk,phik,tldq2,tldw2,tldtm
c      endif
c     pause



      end




      subroutine sffun(sfm,q2,w2,t,phih)
      implicit real*8(a-h,o-z)
      dimension sfm(5)
      common/keys/ivec,iphy,newcase
      common/cmp/pi,alpha,amp,amp2,ap,ap2,aml2,amu2,amh2,barn

      include "deep_input.inc"
      
      sqw2=sqrt(w2)
      iepi=2*ivec-1

      sx=w2+q2-amp2
      aly=sx**2+4.*amp2*q2
      sxt=sx+t+amp2-amu2
      tq=t+q2-amh2

      sqlw=sqrt((W2-amu2-amh2)**2-4.*amu2*amh2)
      sqll=sqrt(q2*sxt**2-sxt*sx*tq-amp2*tq**2-amh2*aly)

      csthcm=(2.*tq*w2+(sx-2.*q2)*(w2+amh2-amu2))/sqlw/sqrt(aly)

c      write(22,'(7g11.3)')q2,w2,t

      if(ivec.eq.1)then
	cspion=-csthcm
      elseif(ivec.eq.2)then
	cspion= csthcm
      endif

      call phy_model(iphy,q2,sqw2,cspion,iepi,st,sl,stt,slt,sltp)
cgpg       print *,'got past phy_model.'

cgpg
cgpg  calculate the cross section and test to see if it goes negative.
cgpg  this is the likely source of the unphysical, negative radiative
cgpg  correction factors we now get when the response functions are small
cgpg  at high beam energy (5.75 GeV) and at perpendicular angles 
cgpg  (cos(theta)= -0.35-0.35).

      enu = 0.5d0*(w2+q2-amp2)/amp
      bmom_prime = bmom - enu
      cthe = 1.d0-q2/(2.0*bmom*bmom_prime)
      the_e = acos(cthe)
      eps_d= 1d0/(1d0+2d0*(1d0+enu*enu/q2)*tan(0.5d0*the_e)**2)

      sig0b = st + eps_d*sl + eps_d*stt*cos(2d0*phih*0)
     .	 + sqrt(eps_d*(eps_d+1d0)/2d0)*slt*cos(phih*0)
      sig0b=sig0b * alpha/2d0/pi*bmom_prime/bmom*(w2-amp2)
     .	 /2./amp/q2/(1d0-eps_d)

      sig0bu=sig0b*pi/2./amp/bmom/bmom_prime

cgpg      write (6,999) sig0bu,st,sl,stt,slt
 999  format('sig0bu=',e8.2,' sig_t=',e8.2,' sig_l=',e8.2,' sig_tt=',
     1           e8.2,' sig_lt=',e8.2)

cgpg if the cross section drops below a certain value, set the response functions
cgpg to their last, above-threshold values. this is rather crude, but it is 
cgpg reasonable efficient and the response functions are below any physically
cgpg relevant value.
cgpg
cgpg first test to see if the structure functions give a below-threshold
cgpg cross section first time through. this may indicate a deeper problem
cgpg so we bail out at this point.

      threshold = 0.0
      if (sig0bu .lt. threshold .and. newcase .eq. 1) then
         print *,'    ************ WARNING IN SFFUN! ************'
         print *,' '
         print *,'The first cross section calculated is',sig0bu,'.'
         print *,' '
         print *,'You are getting very small or even negative cross'
         print *,'sections from your structure functions. We bail'
         print *,'out at this point. See the website for guidance'
         print *,'or get in touch with me.'
         print *,'                            Jerry Gilfoyle'
         print *,'                            gilfoyle@jlab.org'
         print *,' '
         write (6,999) sig0bu,st,sl,stt,slt
         print *,'sig0bu = ',sig0bu,' nu=',enu,' w=',sqrt(w2),' q2=',q2
         print *,'epsilon=',eps_d,' phi=',phih,' sig0b=',sig0b
         print *,'Eprime=',bmom_prime,' W2=',W2,' amp2=',amp2
         print *,'amp=',amp,' Q2=',q2
         print *,'W=',sqrt(w2),'-------------------------------'
         sl  = 0.0
         st  = 0.0
         slt = 0.0
         stt = 0.0
         sl_old = sl
         st_old = st
         slt_old = slt
         stt_old = stt
         stop
      else if (sig0bu .lt. threshold) then
cgpg         write (6,999) sig0bu,st,sl,stt,slt
cgpg         print *,'sig0bu = ',sig0bu,' nu=',enu,' w=',sqrt(w2),' q2=',q2
cgpg         print *,'epsilon=',eps_d,' phi=',phih,' sig0b=',sig0b
cgpg         print *,'Eprime=',bmom_prime,' W2=',W2,' amp2=',amp2
cgpg         print *,'amp=',amp,' Q2=',q2
cgpg         print *,'W=',sqrt(w2),'-------------------------------'
         sl  = sl_old
         st  = st_old
         slt = slt_old
         stt = stt_old
      else
         sl_old = sl
         st_old = st
         slt_old = slt
         stt_old = stt
         newcase = 0
      end if


      if(ivec.eq.1)then
	 slt=-slt
	 sltp=-sltp
      endif

      sfm10=(st-stt)
      sfm20=4.*(st+sl)*q2/aly
      sfm2tl=2.*slt*sqrt(q2)*(-sx*tq+2*q2*sxt)/(aly*sqll)
      sfm4tl=-slt*sqrt(q2)/sqll
      sfm4tt=-2.*stt*(-sx*tq+2*q2*sxt)/sqll**2
      sfm3tt=2.*stt*aly/sqll**2
      sfm2tt=2.*stt*((-sx*tq+2*q2*sxt)**2-2*q2*sqll**2)/(aly*sqll**2)
      sfm5tl=-sltp*sqrt(q2)/sqll


       coetr=16.*pi**2*(w2-amp2)*w2/(alpha*sqlw)

       sfm(1)=coetr*sfm10
       sfm(2)=coetr*(sfm20+sfm2tl+sfm2tt)
       sfm(3)=coetr*sfm3tt
       sfm(4)=coetr*(sfm4tl+sfm4tt)
       sfm(5)=coetr*sfm5tl

c	 write(*,*)q2,w2,t,sfm
c	pause

      end



      subroutine phy_model(iphy,q2,w,csthcm,iepi,st,sl,stt,slt,sltp)
c
      real*8 q2,w,csthcm,st,sl,stt,slt,sltp
      integer iphy, check_sig_LTp
      parameter(pi=3.141592653589793,alpha_qed=1.d0/137.036d0)

cgpg      data check_sig_LTp/0/

c common block for input to wally vanorden's deep code.

      include "deep_input.inc"

      hq2=sngl(q2)
      hw =sngl(w)
      hcs=sngl(csthcm)

      if (iphy.eq.1) then
         print *,'OOPPS! Wrong option for E5. Use option 4.'
      else if ((iphy.eq.2).or.(iphy.eq.3)) then
         print *,'OOPPS! Wrong option for E5. Use option 4.'
      else if (iphy.eq.4) then

c  fill the common block that sets the inputs to wally's deep code.

         itest=1
         Mtgt = 1.8755754
         Mnuc = 0.9389

         nu = (W**2 - Mtgt**2 + Q2)/(2*Mtgt)
         xBJ = Q2/(2*Mnuc*nu)
         filename = "wave_IIB_new"
         i_master=0
         iff=4
         ipwave=0
         inorm=1
         iexch=1
         nthta=1
         deep_x=xBJ
         Q2gev=Q2
         E_beam_gev=bmom
         E_scat_gev=E_beam-nu
         theta_e_deg=2*asin(sqrt(Q2/(4*bmom*(bmom-nu))))
         E_beam_gev_a=bmom
         theta_pq = acos(csthcm)

cgpg         print *,'deep check:',xBJ,deep_x,W,Q2,' nu=',nu,bmom,theta_pq,
cgpg     1           ' csthcm=',csthcm
         call deep(sig_t,sig_l,sig_tt,sig_lt,sig_ltp)

      endif
cgpg      print *,'sig_t=',sig_t,' sig_l=',sig_l,' sig_tt=',sig_tt,' sig_lt=',
cgpg     1         sig_lt,' sig_ltp=',sig_ltp
      st=dble(sig_t)
      sl=dble(sig_l)
      stt=dble(sig_tt)
      slt=dble(sig_lt)
      sltp=dble(sig_ltp)

cgpg       print *,'reached END of phy_model.'

      end

****************** vacpol *************************************

      double precision function vacpol(t)
      implicit real*8(a-h,o-z)
      common/cmp/pi,alpha,amp,amp2,ap,ap2,aml2,amu2,amh2,barn
      dimension am2(3)
c
c    am2 : squared masses of charge leptons
c
      data am2/.26110d-6,.111637d-1,3.18301d0/

      suml=0.
      do 10 i=1,3
	 a2=2.*am2(i)
	 sqlmi=dsqrt(t*t+2.*a2*t)
	 allmi=dlog((sqlmi+t)/(sqlmi-t))/sqlmi
  10  suml=suml+2.*(t+a2)*allmi/3.-10./9.+4.*a2*(1.-a2*allmi)/3./t
      if(t.lt.1.d0)then
	aaa = -1.345d-9
	bbb = -2.302d-3
	ccc = 4.091
      elseif(t.lt.64d0)then
	aaa = -1.512d-3
	bbb =  -2.822d-3
	ccc = 1.218
      else
	aaa = -1.1344d-3
	bbb = -3.0680d-3
	ccc = 9.9992d-1
      endif
      sumh = -(aaa+bbb*log(1.+ccc*t)) *2*pi/alpha

      vacpol=suml+sumh

      end



****************** fspens *************************************

      double precision function fspens(x)
c
c    spence function
c
      implicit real*8(a-h,o-z)
      f=0.d0
      a=1.d0
      an=0.d0
      tch=1.d-16
  1   an=an+1.d0
      a=a*x
      b=a/an**2
      f=f+b
      if(b-tch)2,2,1
  2   fspens=f
      return
      end

      double precision function fspen(x)
      implicit real*8(a-h,o-z)
      data f1/1.644934d0/
cgpg       print *,'x=',x
      if(x)8,1,1
  1   if(x-.5d0)2,2,3
    2 fspen=fspens(x)
      return
    3 if(x-1d0)4,4,5
    4 fspen=f1-dlog(x)*dlog(1d0-x+1d-10)-fspens(1d0-x)
      return
    5 if(x-2d0)6,6,7
    6 fspen=f1-.5*dlog(x)*dlog((x-1d0)**2/x)+fspens(1d0-1d0/x)
      return
    7 fspen=2d0*f1-.5d0*dlog(x)**2-fspens(1d0/x)
      return
    8 if(x+1d0)10,9,9
   9  fspen=-.5d0*dlog(1d0-x)**2-fspens(x/(x-1d0))
      return
  10  fspen=-.5*dlog(1.-x)*dlog(x**2/(1d0-x))-f1+fspens(1d0/(1d0-x))
      return
      end


************ titout **************************
      subroutine titout(date)
      implicit real*8(a-h,o-z)
      character*10 date

      open(unit=9,file='all.dat')
      open(unit=21,file='allu.dat')
	 write(9,1)date
	 write(9,3)
3     format(/' the file contains work information about'/
     .' contribution of tails')
1     format(1x,'program DIFFRAD 1.0 version from ',a10)
      end


      subroutine simpsx(a,b,np,ep,func,res)
      implicit real*8(a-h,o-z)
      external func
      step=(b-a)/np
      call simps(a,b,step,ep,1d-18,func,ra,res,r2,r3)
      end
      subroutine simptx(a,b,np,ep,func,res)
      implicit real*8(a-h,o-z)
      external func
      step=(b-a)/np
      call simpt(a,b,step,ep,1d-18,func,ra,res,r2,r3)
      end
      subroutine simpux(a,b,np,ep,func,res)
      implicit real*8(a-h,o-z)
      external func
      step=(b-a)/np
      call simpu(a,b,step,ep,1d-18,func,ra,res,r2,r3)
      end

      subroutine simps(a1,b1,h1,reps1,aeps1,excl_funct,x,ai,aih,aiabs)
c simps
c a1,b1 -the limits of integration
c h1 -an initial step of integration
c reps1,aeps1 - relative and absolute precision of integration
c excl_funct -a name of function subprogram for calculation of integrand +
c x - an argument of the integrand
c ai - the value of integral
c aih- the value of integral with the step of integration
c aiabs- the value of integral for module of the integrand
c this subrogram calculates the definite integral with the relative or
c absolute precision by simpson+s method with the automatical choice
c of the step of integration
c if aeps1    is very small(like 1.e-17),then calculation of integral
c with reps1,and if reps1 is very small (like 1.e-10),then calculation
c of integral with aeps1
c when aeps1=reps1=0. then calculation with the constant step h1
c
      implicit real*8(a-h,o-z)
      dimension f(7),p(5)
      h=dsign(h1,b1-a1)
      s=dsign(1.d0,h)
      a=a1
      b=b1
      ai=0.d0
      aih=0.d0
      aiabs=0.d0
      p(2)=4.d0
      p(4)=4.d0
      p(3)=2.d0
      p(5)=1.d0
      if(b-a) 1,2,1
    1 reps=dabs(reps1)
      aeps=dabs(aeps1)
      do 3 k=1,7
  3   f(k)=10.d16
      x=a
      c=0.d0
      f(1)=excl_funct(x)/3.d0
    4 x0=x
      if((x0+4.*h-b)*s) 5,5,6
    6 h=(b-x0)/4.
      if(h) 7,2,7
    7 do 8 k=2,7
  8   f(k)=10.d16
      c=1.d0
    5 di2=f(1)
      di3=dabs(f(1))
      do 9 k=2,5
      x=x+h
      if((x-b)*s) 23,24,24
   24 x=b
   23 if(f(k)-10.d16) 10,11,10
   11 f(k)=excl_funct(x)/3.
   10 di2=di2+p(k)*f(k)
    9 di3=di3+p(k)*abs(f(k))
      di1=(f(1)+4.*f(3)+f(5))*2.*h
      di2=di2*h
      di3=di3*h
      if(reps) 12,13,12
   13 if(aeps) 12,14,12
   12 eps=dabs((aiabs+di3)*reps)
      if(eps-aeps) 15,16,16
   15 eps=aeps
   16 delta=dabs(di2-di1)
      if(delta-eps) 20,21,21
   20 if(delta-eps/8.) 17,14,14
   17 h=2.*h
      f(1)=f(5)
      f(2)=f(6)
      f(3)=f(7)
      do 19 k=4,7
  19  f(k)=10.d16
      go to 18
   14 f(1)=f(5)
      f(3)=f(6)
      f(5)=f(7)
      f(2)=10.d16
      f(4)=10.d16
      f(6)=10.d16
      f(7)=10.d16
   18 di1=di2+(di2-di1)/15.
      ai=ai+di1
      aih=aih+di2
      aiabs=aiabs+di3
      go to 22
   21 h=h/2.
      f(7)=f(5)
      f(6)=f(4)
      f(5)=f(3)
      f(3)=f(2)
      f(2)=10.d16
      f(4)=10.d16
      x=x0
      c=0.d0
      go to 5
   22 if(c) 2,4,2
    2 return
      end


      subroutine simpt(a1,b1,h1,reps1,aeps1,excl_funct,x,ai,aih,aiabs)
      implicit real*8(a-h,o-z)
      dimension f(7),p(5)
      h=dsign(h1,b1-a1)
      s=dsign(1.d0,h)
      a=a1
      b=b1
      ai=0.d0
      aih=0.d0
      aiabs=0.d0
      p(2)=4.d0
      p(4)=4.d0
      p(3)=2.d0
      p(5)=1.d0
      if(b-a) 1,2,1
    1 reps=dabs(reps1)
      aeps=dabs(aeps1)
      do 3 k=1,7
  3   f(k)=10.d16
      x=a
      c=0.d0
      f(1)=excl_funct(x)/3.
    4 x0=x
      if((x0+4.*h-b)*s) 5,5,6
    6 h=(b-x0)/4.
      if(h) 7,2,7
    7 do 8 k=2,7
  8   f(k)=10.d16
      c=1.d0
    5 di2=f(1)
      di3=dabs(f(1))
      do 9 k=2,5
      x=x+h
      if((x-b)*s) 23,24,24
   24 x=b
   23 if(f(k)-10.d16) 10,11,10
   11 f(k)=excl_funct(x)/3.
   10 di2=di2+p(k)*f(k)
    9 di3=di3+p(k)*abs(f(k))
      di1=(f(1)+4.*f(3)+f(5))*2.*h
      di2=di2*h
      di3=di3*h
      if(reps) 12,13,12
   13 if(aeps) 12,14,12
   12 eps=dabs((aiabs+di3)*reps)
      if(eps-aeps) 15,16,16
   15 eps=aeps
   16 delta=dabs(di2-di1)
      if(delta-eps) 20,21,21
   20 if(delta-eps/8.) 17,14,14
   17 h=2.*h
      f(1)=f(5)
      f(2)=f(6)
      f(3)=f(7)
      do 19 k=4,7
  19  f(k)=10.d16
      go to 18
   14 f(1)=f(5)
      f(3)=f(6)
      f(5)=f(7)
      f(2)=10.d16
      f(4)=10.d16
      f(6)=10.d16
      f(7)=10.d16
   18 di1=di2+(di2-di1)/15.
      ai=ai+di1
      aih=aih+di2
      aiabs=aiabs+di3
      go to 22
   21 h=h/2.
      f(7)=f(5)
      f(6)=f(4)
      f(5)=f(3)
      f(3)=f(2)
      f(2)=10.d16
      f(4)=10.d16
      x=x0
      c=0.d0
      go to 5
   22 if(c) 2,4,2
    2 return
      end

      subroutine simpu(a1,b1,h1,reps1,aeps1,excl_funct,x,ai,aih,aiabs)
      implicit real*8(a-h,o-z)
      dimension f(7),p(5)
      h=dsign(h1,b1-a1)
      s=dsign(1.d0,h)
      a=a1
      b=b1
      ai=0.d0
      aih=0.d0
      aiabs=0.d0
      p(2)=4.d0
      p(4)=4.d0
      p(3)=2.d0
      p(5)=1.d0
      if(b-a) 1,2,1
    1 reps=dabs(reps1)
      aeps=dabs(aeps1)
      do 3 k=1,7
  3   f(k)=10.d16
      x=a
      c=0.d0
      f(1)=excl_funct(x)/3.
    4 x0=x
      if((x0+4.*h-b)*s) 5,5,6
    6 h=(b-x0)/4.
      if(h) 7,2,7
    7 do 8 k=2,7
  8   f(k)=10.d16
      c=1.d0
    5 di2=f(1)
      di3=dabs(f(1))
      do 9 k=2,5
      x=x+h
      if((x-b)*s) 23,24,24
   24 x=b
   23 if(f(k)-10.d16) 10,11,10
   11 f(k)=excl_funct(x)/3.
   10 di2=di2+p(k)*f(k)
    9 di3=di3+p(k)*abs(f(k))
      di1=(f(1)+4.*f(3)+f(5))*2.*h
      di2=di2*h
      di3=di3*h
      if(reps) 12,13,12
   13 if(aeps) 12,14,12
   12 eps=dabs((aiabs+di3)*reps)
      if(eps-aeps) 15,16,16
   15 eps=aeps
   16 delta=dabs(di2-di1)
      if(delta-eps) 20,21,21
   20 if(delta-eps/8.) 17,14,14
   17 h=2.*h
      f(1)=f(5)
      f(2)=f(6)
      f(3)=f(7)
      do 19 k=4,7
  19  f(k)=10.d16
      go to 18
   14 f(1)=f(5)
      f(3)=f(6)
      f(5)=f(7)
      f(2)=10.d16
      f(4)=10.d16
      f(6)=10.d16
      f(7)=10.d16
   18 di1=di2+(di2-di1)/15.
      ai=ai+di1
      aih=aih+di2
      aiabs=aiabs+di3
      go to 22
   21 h=h/2.
      f(7)=f(5)
      f(6)=f(4)
      f(5)=f(3)
      f(3)=f(2)
      f(2)=10.d16
      f(4)=10.d16
      x=x0
      c=0.d0
      go to 5
   22 if(c) 2,4,2
    2 return
      end

      subroutine d01fce(ndim, a, b, minpts, maxpts, functn, eps,
     * acc, lenwrk, wrkstr, finval, ifail)
      implicit real*8(a-h,o-z)
c     mark 8 release. nag copyright 1979.
c
c     adaptive multidimensional integration subroutine
c
c     *********  parameters for d01fce ****************************
c
c      input parameters
c
c     ndim    integer number of variables, must exceed 1 but
c	  not exceed 15.
c
c     a       real array of lower limits, with dimension ndim
c
c     b       real array of upper limits, with dimension ndim
c
c     minpts  integer minimum number of integrand values to be
c	  allowed, which must not exceed maxpts.
c
c     maxpts  integer maximum number of integrand values to be
c	  allowed, which must be at least
c	  2**ndim+2*ndim**2+2*ndim+1.
c
c     functn  externally declared user defined real function
c	  integrand. it must have parameters (ndim,z),
c	  where z is a real array of dimension ndim.
c
c     eps     real required relative accuracy, must be greater
c	  than zero
c
c     lenwrk  integer length of array wrkstr, must be at least
c	  2*ndim+4.
c
c     ifail   integer nag failure parameter
c	  ifail=0 for hard fail
c	  ifail=1 for soft fail
c
c      output parameters
c
c     minpts  integer number of integrand values used by the
c	  routine
c
c     wrkstr  real array of working storage of dimension (lenwrk).
c
c     acc     real estimated relative accuracy of finval
c
c     finval  real estimated value of integral
c
c     ifail   ifail=0 for normal exit, when estimated relative
c	    less integaccuracy rand values used.
c
c      ifail=1 if ndim.lt.2, ndim.gt.15, minpts.gt.maxpts,
c	    maxpts.lt.2**ndim+2*ndim*(ndim+1)+1, eps.le.0
c	    or lenwrk.lt.2*ndim+4.
c
c      ifail=2 if maxpts was too small for d01fce to obtain the
c	    required relative accuracy eps.  in this
c	    case d01fce returns a value of finval
c	    with estimated relative accuracy acc.
c
c      ifail=3 if lenwrk too small for maxpts integrand
c	    values.  in this case d01fce returns a
c	    value of finval with estimated accuracy
c	    acc using the working storage
c	    available, but acc will be greater
c	    than eps.
c
c     **************************************************************
c
c     .. scalar arguments ..
*     real eps, finval, acc
*     integer ifail, lenwrk, maxpts, minpts, ndim
c     .. array arguments ..
**    real a(ndim), b(ndim), wrkstr(lenwrk)
      dimension a(ndim), b(ndim), wrkstr(lenwrk)
c     .. function arguments ..
*     real functn
c     ..
c     .. local scalars ..
      character*8 srname
      double precision
     * abserr, df1, df2, difmax, f1, f2, f3, f4, half, lamda2,
     * lamda4, lamda5, one, ratio, rgncmp, rgnerr, rgnert, rgnval,
     * rgnvlt, rgnvol, rlndim, sum1, sum2, sum3, sum4, sum5, two,
     * twondm, weit1, weit2, weit3, weit4, weit5, weitp1, weitp2,
     * weitp3, weitp4, zero
      integer dvaxes, dvaxis, dvflag, funcls, ierror, j, k, maxaxs,
     * mxrgns, pointr, rgncls, rulcls, sbrgns, subrgn, subtmp,
     * tpontp, tpontr
c     .. local arrays ..
      dimension center(15), dif(15), oldcnt(15), width(15), z(15)
      integer dvcntl(15), dvcntr(15)
c     .. function references ..
*     real sqrt, x02aae
      integer p01aae, x02bbe
c     ..
      data srname /'  d01fce'/
      data zero, one, two, half /0.d0, 1.d0, 2.d0, 0.5d0/
      common/test/ipol

cgpg      print *,'ipol=',ipol

c
c   subroutine initialisation and parameter checking
c
      if (ndim.lt.2 .or. ndim.gt.15) go to 560
      if (minpts.gt.maxpts) go to 560
      if (eps.le.zero) go to 560
      if (lenwrk.lt.2*ndim+4) go to 560
      funcls = 0
      finval = zero
      abserr = zero
      twondm = two**ndim
      rgnvol = twondm
      dvflag = 1
      fffff1 = float(x02bbe(one))
      fffff2 = 1.0/x02aae(0.0d0)
      maxaxs = int(dmin1(fffff1,fffff2))
c     maxaxs = int(amin1(float(x02bbe(one)),1.0/x02aae(0.0d0)))
      maxaxs = (maxaxs-ndim)/(ndim+1)
      mxrgns = lenwrk/(2*ndim+4)
      sbrgns = 0
      rgnvlt = zero
      rgnert = zero
      do 20 j=1,ndim
       center(j) = (a(j)+b(j))*half
       dif(j) = zero
       width(j) = (b(j)-a(j))*half
       dvcntl(j) = 1
       dvcntr(j) = 1
       oldcnt(j) = center(j)
       rgnvol = rgnvol*width(j)
   20 continue
c
c   end subroutine initialisation
c   basic rule initialisation
c
      rulcls = 2**ndim + 2*ndim*ndim + 2*ndim + 1
      funcls = rulcls
      if (maxpts.lt.rulcls) go to 560
      rlndim = ndim
      lamda2 = sqrt(9.0/70.0)
      lamda4 = sqrt(9.0/10.0)
      lamda5 = sqrt(9.0/19.0)
      weit1 = (12824.0-9120.0*rlndim+400.0*rlndim*rlndim)/19683.0
      weit2 = 980.0/6561.0
      weit3 = (1820.0-400.0*rlndim)/19683.0
      weit4 = 200.0/19683.0
      weit5 = 6859.0/19683.0/twondm
      weitp1 = (729.0-950.0*rlndim+50.0*rlndim**2)/729.0
      weitp2 = 245.0/486.0
      weitp3 = (265.0-100.0*rlndim)/1458.0
      weitp4 = 25.0/729.0
      ratio = (lamda2/lamda4)**2
c
c   end basic rule initialisation
      go to 100
c   divide subregion with largest error and prepare to use
c   basic rule on each portion
c
   40 subrgn = 1
      pointr = wrkstr(1)
      rgncls = rulcls
      rgnvol = twondm
      tpontr = pointr + 2
      do 60 j=1,ndim
       tpontr = tpontr + 2
       center(j) = wrkstr(tpontr-1)
       width(j) = wrkstr(tpontr)
       dvcntr(j) = 1
       dvcntl(j) = 1
       oldcnt(j) = center(j)
       rgnvol = rgnvol*width(j)
   60 continue
      dvaxes = wrkstr(pointr+2)
      if (dvaxes.lt.0) go to 600
   80 dvaxis = dvaxes
      dvaxes = dvaxis/(ndim+1)
      dvaxis = dvaxis - (ndim+1)*dvaxes
      dvcntl(dvaxis) = 2*dvcntl(dvaxis)
      rgncls = rgncls*2
cgpg      if (ipol.eq.2) print *,'test on dvaxes. ndim=',ndim
      if (dvaxes.gt.0) go to 80
      if (funcls+rgncls.gt.maxpts) go to 580
      if (rgncls/rulcls+sbrgns-1.gt.mxrgns) dvflag = 2
      funcls = funcls + rgncls
cgpg      if (ipol.eq.2) print *,funcls
      abserr = abserr - wrkstr(pointr)
      finval = finval - wrkstr(pointr+1)
c
c   begin basic rule
  100 do 120 j=1,ndim
       z(j) = center(j)
  120 continue
      sum1 = functn(ndim,z)
      sum2 = zero
      sum3 = zero
      do 140 j=1,ndim
       z(j) = center(j) - lamda2*width(j)
       f1 = functn(ndim,z)
       z(j) = center(j) + lamda2*width(j)
       f2 = functn(ndim,z)
       z(j) = center(j) - lamda4*width(j)
       f3 = functn(ndim,z)
       z(j) = center(j) + lamda4*width(j)
       f4 = functn(ndim,z)
       sum2 = sum2 + f1 + f2
       sum3 = sum3 + f3 + f4
       df1 = f1 + f2 - two*sum1
       df2 = f3 + f4 - two*sum1
       dif(j) = dif(j) + abs(df1-ratio*df2)
       z(j) = center(j)
  140 continue
      sum4 = zero
      do 200 j=2,ndim
       z(j-1) = center(j-1) - lamda4*width(j-1)
       do 160 k=j,ndim
	  z(k) = center(k) - lamda4*width(k)
	  sum4 = sum4 + functn(ndim,z)
	  z(k) = center(k) + lamda4*width(k)
	  sum4 = sum4 + functn(ndim,z)
	  z(k) = center(k)
  160  continue
       z(j-1) = center(j-1) + lamda4*width(j-1)
       do 180 k=j,ndim
	  z(k) = center(k) - lamda4*width(k)
	  sum4 = sum4 + functn(ndim,z)
	  z(k) = center(k) + lamda4*width(k)
	  sum4 = sum4 + functn(ndim,z)
	  z(k) = center(k)
  180  continue
       z(j-1) = center(j-1)
  200 continue
      sum5 = zero
      do 220 j=1,ndim
       z(j) = center(j) - lamda5*width(j)
  220 continue
  240 do 260 j=2,ndim
       if (z(j-1).lt.center(j-1)+width(j-1)) go to 280
       z(j-1) = center(j-1) - lamda5*width(j-1)
       z(j) = z(j) + two*lamda5*width(j)
  260 continue
      if (z(ndim).gt.center(ndim)+width(ndim)) go to 300
  280 sum5 = sum5 + functn(ndim,z)
      z(1) = z(1) + two*lamda5*width(1)
      go to 240
  300 rgnval = rgnvol*(weit1*sum1+weit2*sum2+weit3*sum3+weit4*
     * sum4+weit5*sum5)
cgpg      if (ipol.eq.2) print *,'got past z test.'
      rgncmp = rgnvol*(weitp1*sum1+weitp2*sum2+weitp3*sum3+weitp4*
     * sum4)
      rgnerr = abs(rgnval-rgncmp)
c
c   end basic rule
c   store results of basic rule application
c
      rgnvlt = rgnvlt + rgnval
      rgnert = rgnert + rgnerr
      finval = finval + rgnval
      abserr = abserr + rgnerr
      if (dvflag.eq.0) go to 340
      if (dvflag.eq.2) go to 500
      pointr = mxrgns + sbrgns*(2*ndim+3) + 1
      sbrgns = sbrgns + 1
      wrkstr(sbrgns) = pointr
      subrgn = sbrgns
      tpontr = pointr + 2
      do 320 j=1,ndim
       tpontr = tpontr + 2
       wrkstr(tpontr-1) = center(j)
       wrkstr(tpontr) = width(j)
  320 continue
  340 wrkstr(pointr) = rgnert
      wrkstr(pointr+1) = rgnvlt
c   determine axis along which fourth difference is largest
      difmax = zero
      do 380 j=1,ndim
       if (difmax.gt.dif(j)) go to 360
       difmax = dif(j)
       dvaxis = j
  360	    dif(j) = zero
  380 continue
      tpontr = pointr + 2*(dvaxis+1)
      wrkstr(tpontr) = width(dvaxis)*half
      wrkstr(tpontr-1) = center(dvaxis) - wrkstr(tpontr)
      if (dvflag.ne.2) go to 400
      dvaxes = wrkstr(pointr+2)
      if (dvaxes.gt.maxaxs) dvaxes = -1
      dvaxis = dvaxis + (ndim+1)*dvaxes
  400 wrkstr(pointr+2) = dvaxis
      if (dvflag.eq.1) go to 460
c   determine the position in the parially ordered list of
c   the subregion which replaces most recently divided subregion
  420 subtmp = 2*subrgn
      if (subtmp.gt.sbrgns) go to 480
      tpontr = wrkstr(subtmp)
      if (subtmp.eq.sbrgns) go to 440
      tpontp = wrkstr(subtmp+1)
      if (wrkstr(tpontr).ge.wrkstr(tpontp)) go to 440
      subtmp = subtmp + 1
      tpontr = tpontp
  440 if (rgnert.ge.wrkstr(tpontr)) go to 480
      wrkstr(subtmp) = pointr
      wrkstr(subrgn) = tpontr
      subrgn = subtmp
cgpg      if (ipol.eq.2) print *,'return to 420.'
      go to 420
c   when working storage is not used up, determine the
c   position in the partially ordered list for the description
c   of other portion(s) of most recently divided subregion
  460 subtmp = subrgn/2
      if (subtmp.lt.1) go to 480
      tpontr = wrkstr(subtmp)
      if (rgnert.le.wrkstr(tpontr)) go to 480
      wrkstr(subtmp) = pointr
      wrkstr(subrgn) = tpontr
      subrgn = subtmp
cgpg      if (ipol.eq.2) print *,'return to 460.'
      go to 460
  480 rgnvlt = zero
      rgnert = zero
      if (dvflag.eq.2) go to 540
      dvflag = 1 - dvflag
c   count to determine the next part of the recently divided
c   subregion for application of the basic rule
  500 center(1) = center(1) + two*width(1)
      dvcntr(1) = dvcntr(1) + 1
      do 520 j=2,ndim
       if (dvcntr(j-1).le.dvcntl(j-1)) go to 100
       dvcntr(j-1) = 1
       center(j-1) = oldcnt(j-1)
       dvcntr(j) = dvcntr(j) + 1
       center(j) = center(j) + two*width(j)
  520 continue
      if (dvcntr(ndim).le.dvcntl(ndim)) then
cgpg         if (ipol.eq.2) print *,'failed dvcntr test.'
         go to 100
      end if
      center(ndim) = oldcnt(ndim)
      if (dvflag.eq.2) then
cgpg         if (ipol.eq.2) print *,'failed dvflag test.'
         go to 340
      end if
c
c   end ordering of basic rule results
c   make checks for possible termination of routine
c
  540 acc = abserr/abs(finval)
cgpg      if (ipol.eq.2) print *,'acc=',acc,' eps=',eps,' funcls=',
cgpg     1                       funcls,' minpts=',minpts
      if (acc.gt.eps .or. funcls.lt.minpts) then
cgpg         if (ipol.eq.2) print *,'failed acc, funcls test.'
         go to 40
      end if
c
c   loop back to apply basic rule
c
c   termination point, set ifail and return
c
      ierror = 0
      go to 620
  560 ierror = 1
      go to 620
  580 ierror = 2
      go to 620
  600 ierror = 3
  620 minpts = funcls
      ifail = p01aae(ifail,ierror,srname)
      return
      end

      double precision function x02aae(x)
      implicit real*8(a-h,o-z)
c     nag copyright 1975
c     mark 4.5 release
c+self,if=ibm.
cc     for ibm/360/370/3090
c      data z/z3380000000000000/
c      x02aae = z
c     for sun
      data z/1.1d-16/
      x02aae = z
c     * eps *
c     returns the value eps where eps is the smallest
c     positive
c     number such that 1.0 + eps > 1.0
c     the x parameter is not used
c     for icl 1900
c     x02aae = 2.0**(-37.0)
c+self,if=pc.
c     for pdp11
c      x02aae=2.d0**(-23.d0)
c+self.

      return
      end
c
      integer  function x02bbe(x)
      implicit real*8(a-h,o-z)
c     nag copyright 1975
c     mark 4.5 release
*     real x
c     * maxint *
c     returns the largest integer representable on the computer
c     the x parameter is not used
c     for icl 1900
c      x02bbe = 8388607
c     for ibm,sun,vax,ibm pc/386/486
       x02bbe = 2147483647
c   for pdp11
c     x02bbe=32767
      return
      end

      integer function p01aae(ifail, error, srname)
c     mark 1 release.  nag copyright 1971
c     mark 3 revised
c     mark 4a revised, ier-45
c     mark 4.5 revised
c     mark 7 revised (dec 1978)
c     returns the value of error or terminates the program.
      integer error, ifail, nout
      character*8 srname
c     test if no error detected
      if (error.eq.0) go to 20
c     determine output unit for message
      call x04aae (0,nout)
c     test for soft failure
      if (mod(ifail,10).eq.1) go to 10
c     hard failure
      write (nout,99999) srname, error
c     stopping mechanism may also differ
      stop
c     soft fail
c     test if error messages suppressed
   10 if (mod(ifail/10,10).eq.0) go to 20
      write (nout,99999) srname, error
   20 p01aae = error
      return
99999 format (1h0, 38herror detected by nag library routine , a8,
     * 11h - ifail = , i5//)
      end
      subroutine x04aae(i,nerr)
c     mark 7 release. nag copyright 1978
c     mark 7c revised ier-190 (may 1979)
c     if i = 0, sets nerr to current error message unit number
c     (stored in nerr1).
c     if i = 1, changes current error message unit number to
c     value specified by nerr.
c
c     *** note ***
c     this routine assumes that the value of nerr1 is saved
c     between calls.  in some implementations it may be
c     necessary to store nerr1 in a labelled common
c     block /ax04aa/ to achieve this.
c
c     .. scalar arguments ..
      integer i, nerr
c     ..
c     .. local scalars ..
      integer nerr1
c     ..
      data nerr1 /5/
      if (i.eq.0) nerr = nerr1
      if (i.eq.1) nerr1 = nerr
      return
      end
